<template>
  <div id="news-index">
    <data-table :fields="fields" :opera="opera" :data="list" :total="total" @query="search" @edit="toEdit" @delete="toDelete">
      <template #selfbtn>
        <el-button type="primary" size="mini" @click="toAdd">添加新闻</el-button>
      </template>
      <template #options="{ item }">
        <template v-if="item.prop === 'column_name'">
          <el-option v-for="(i, index) in typeList" :key="`columns-name-${index}`" :label="i" :value="i"></el-option>
        </template>
      </template>
    </data-table>
  </div>
</template>

<script>
const { newsColumn } = require('@common/dict/index');
import { mapState, createNamespacedHelpers } from 'vuex';
const { mapActions: news } = createNamespacedHelpers('news');
export default {
  name: 'newsIndex',
  props: {},
  components: {},
  data: function () {
    return {
      list: [],
      total: 0,
      opera: [
        {
          label: '修改',
          method: 'edit',
        },
        {
          label: '删除',
          method: 'delete',
          type: 'danger',
        },
      ],
      fields: [
        { label: '栏目名称', prop: 'column_name', filter: 'select' },
        { label: '标题', prop: 'title', filter: true },
        { label: '来源', prop: 'origin' },
        { label: '发布时间', prop: 'release_time' },
      ],
      typeList: newsColumn,
    };
  },
  created() {
    this.search();
  },
  methods: {
    ...news(['query', 'delete']),
    async search({ skip = 0, limit = 10, ...info } = {}) {
      const res = await this.query({ skip, limit, ...info });
      if (this.$checkRes(res)) {
        this.$set(this, `list`, res.data);
        this.$set(this, `total`, res.total);
      }
    },
    toAdd() {
      this.$router.push('/adminCenter/news/detail');
    },
    toEdit({ data }) {
      this.$router.push({ path: '/adminCenter/news/detail', query: { id: data._id } });
    },
    async toDelete({ data }) {
      const res = await this.delete(data._id);
      if (this.$checkRes(res, '删除成功', '删除失败')) {
        this.search();
      }
    },
  },
  computed: {
    ...mapState(['user', 'menuParams']),
    pageTitle() {
      return `${this.$route.meta.title}`;
    },
  },
  metaInfo() {
    return { title: this.$route.meta.title };
  },
};
</script>

<style lang="less" scoped></style>
